local function superemeraldcheck(player)
	if gametype == GT_COOP or gametype == GT_COMPETITION or gametype == GT_RACE then
		if not All7Emeralds(emeralds) then
			P_SpawnMobj(player.mo.x,player.mo.y,player.mo.z, MT_EMERALD1)
			P_SpawnMobj(player.mo.x,player.mo.y,player.mo.z, MT_EMERALD2)
			P_SpawnMobj(player.mo.x,player.mo.y,player.mo.z, MT_EMERALD3)
			P_SpawnMobj(player.mo.x,player.mo.y,player.mo.z, MT_EMERALD4)
			P_SpawnMobj(player.mo.x,player.mo.y,player.mo.z, MT_EMERALD5)
			P_SpawnMobj(player.mo.x,player.mo.y,player.mo.z, MT_EMERALD6)
			P_SpawnMobj(player.mo.x,player.mo.y,player.mo.z, MT_EMERALD7)
		end
	end
end

addHook("PlayerThink", superemeraldcheck)

local function superforall(player)
	if player.mo and player.valid then
		if not (player.charflags & SF_SUPER) then
			player.charflags = $1 + SF_SUPER
		end
	end
end

addHook("PlayerThink", superforall)

addHook("PlayerThink", function(player)
    if gametype == GT_COOP then
		if player.mo and player.valid and All7Emeralds(emeralds) and not player.exiting then
			if (player.rings < 1) and not player.powers[pw_super] then
				player.mo.state = S_PLAY_SUPER_TRANS1
				S_StartSound(player.mo, sfx_supert)
				player.rings = $1 + 2
				player.powers[pw_super] = 1
			elseif (player.rings < 2) then
				player.rings = $1 + 1
			end
		end
	end
end)

addHook("PlayerThink", function(player)
    if gametype == GT_COMPETITION then
		if player.mo and player.valid and All7Emeralds(emeralds) and not player.exiting then
			if (player.rings < 1) and not player.powers[pw_super] then
				player.mo.state = S_PLAY_SUPER_TRANS1
				S_StartSound(player.mo, sfx_s3k46)
				player.rings = 2
				player.powers[pw_super] = 1
			elseif (player.rings < 2) then
				player.rings = 2
			end
		end
	end
end)

addHook("PlayerThink", function(player)
    if gametype == GT_RACE then
		if player.mo and player.valid and All7Emeralds(emeralds) and not player.exiting then
			if (player.rings < 1) and not player.powers[pw_super] then
				player.powers[pw_super] = 1
				player.rings = 10
				player.mo.state = S_PLAY_SUPER_TRANS1
				S_StartSound(player.mo, sfx_s3k9f)
			end
		end
	end
end)

addHook("MapLoad", do
	for player in players.iterate
		if player.mo and player.valid and gametype == GT_RACE then
			player.rings = 54
		end
	end
end)